
Object.defineProperty(exports, '__esModule', { value: true });
function getPort(code, start) {
	let portType = '';
	let complex = '';
	let from = '';
	let name = '';
	let newName = '';
	let asActive = false;
	let fromActive = false;
	const len = code.length;
	portType = code[start];
	if (code[start + 1] !== 'm' && code[start + 1] !== 'x') return false;
	portType += code[start + 1];
	if (code.substr(start + 2, 5) !== 'port ') return false;
	const getSection = (indx, end) => {
		let ind = indx;
		let wrd = code[indx];
		const reg = new RegExp(`${end}|;|\\(|\\{|=`);
		while (++ind < len && !reg.test(code[ind])) wrd += code[ind];
		return wrd;
	};
	let current = `${portType}port`;
	for (let i = start + 6; i < len; i++) {
		const char = code[i];
		current += char;
		if (!/\s/.test(char)) {
			if (char === '{') {
				if (name || from || asActive || fromActive || complex) return true;
				complex = getSection(i + 1, '}');
				current += `${complex}}`;
				i += complex.length + 1;
				complex = complex.replace(/\n\r\t\f\v/g, ' ');
				complex = complex.replace(/ +/g, ' ');
			} else if (char === '"' || char === "'") {
				from = getSection(i + 1, char);
				current += from + char;
				i += from.length + 1;
			} else if (char === ';') i = len;
			else {
				const wrd = getSection(i, '\\s');
				if (wrd === 'from') fromActive = true;
				else if (wrd === 'as') asActive = true;
				else if (!name) name = wrd;
				else if (asActive) newName = wrd;
				else if (fromActive) from = wrd;
				else return true;
				if (wrd !== 'from') fromActive = false;
				if (wrd !== 'as') asActive = false;
				current += wrd.substr(1);
				i += wrd.length - 1;
			}
		} else if (from && /\n|\r/.test(char)) i = len;
	}
	const member = {
		from,
		name,
		as: newName,
		portType,
		complex,
	};
	if (!member.from && !member.complex) return true;
	return { member, str: current };
}
exports.getPort = getPort;
function getComment(code, start) {
	let result = '/';
	if (code[start + 1] === '*') result += '*';
	else if (code[start + 1] === '/') result += '/';
	if (result.length === 1) return result;
	let i = start + 2;
	const endofline = result === '//';
	let star = false;
	for (const len = code.length; i < len; i++) {
		const char = code[i];
		if (char === '*') star = true;
		else if (char === '/' && star) return `${result}*/`;
		else if (char === '\n' && endofline) {
			if (code[i + 1] === '\r') return `${result}\n\r`;
			return `${result}\n`;
		} else {
			if (star) result += '*';
			star = false;
			result += char;
		}
	}
	return result;
}
exports.getComment = getComment;
function testModule(code, start) {
	let i = start;
	const len = code.length;
	let str = '';
	let spaces = '';
	let result = '';
	for (; i < len; i++) {
		const char = code[i];
		if (char === ' ' || char === '\t' || char === '\n' || char === '\r') {
			if (str) {
				switch (str) {
					case 'declare':
						result = 'declare';
						str = '';
						spaces = char;
						break;
					case 'module':
						result += `${spaces}module`;
						return result.length;
					default:
						return result.length;
				}
			} else spaces += char;
		} else str += char;
	}
	return 0;
}
exports.testModule = testModule;
function getNewName(nameAs) {
	if (!nameAs) return { name: nameAs };
	const [, name, , newName] = /(\*|\w+)( *as *(\w+))?/.exec(nameAs);
	return { name, as: newName };
}
exports.getNewName = getNewName;
